<?php
/**
 * Clase Base DP para BasePlaEmpresaDP
 *
 * @package    
 * @subpackage BasePlaEmpresaDP
 * @author     Willy
 * @version    SVN:: BasePlaEmpresaDP.class.php,v 1.1 2022-07-25 11:37:41 william.taype Exp $
 */
abstract class BasePlaEmpresaDP extends PlaEmpresaBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof PlaEmpresaBN )
    {
      $o_PlaEmpresaBN = $bSetDefault;
      if($o_PlaEmpresaBN->getIdEmpresa()) : $this->setIdEmpresa($o_PlaEmpresaBN->getIdEmpresa()); endif;
      if($o_PlaEmpresaBN->getDescripcion()) : $this->setDescripcion($o_PlaEmpresaBN->getDescripcion()); endif;
      if($o_PlaEmpresaBN->getRUC()) : $this->setRUC($o_PlaEmpresaBN->getRUC()); endif;
      if($o_PlaEmpresaBN->getRutaLogo()) : $this->setRutaLogo($o_PlaEmpresaBN->getRutaLogo()); endif;
      if($o_PlaEmpresaBN->getEstado()) : $this->setEstado($o_PlaEmpresaBN->getEstado()); endif;
      if($o_PlaEmpresaBN->getFechaCreacion()) : $this->setFechaCreacion($o_PlaEmpresaBN->getFechaCreacion()); endif;
      if($o_PlaEmpresaBN->getUsuarioCreacion()) : $this->setUsuarioCreacion($o_PlaEmpresaBN->getUsuarioCreacion()); endif;
      if($o_PlaEmpresaBN->getFechaModificacion()) : $this->setFechaModificacion($o_PlaEmpresaBN->getFechaModificacion()); endif;
      if($o_PlaEmpresaBN->getUsuarioModificacion()) : $this->setUsuarioModificacion($o_PlaEmpresaBN->getUsuarioModificacion()); endif;
      if($o_PlaEmpresaBN->getEliminado()) : $this->setEliminado($o_PlaEmpresaBN->getEliminado()); endif;
      if($o_PlaEmpresaBN->getUsuarioEliminado()) : $this->setUsuarioEliminado($o_PlaEmpresaBN->getUsuarioEliminado()); endif;
      if($o_PlaEmpresaBN->getFechaEliminado()) : $this->setFechaEliminado($o_PlaEmpresaBN->getFechaEliminado()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdEmpresa),(MAX(IdEmpresa)+1), 1) AS Maximo FROM pla_empresa;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdEmpresa($row[0]);

      if($this->getIdEmpresa()){
        $a_Fields = array();

        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getDescripcion()); endif;
        if($this->getRUC()) : $a_Fields['RUC'] = ($this->getRUC()); endif;
        if($this->getRutaLogo()) : $a_Fields['RutaLogo'] = ($this->getRutaLogo()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;
        if($this->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getFechaModificacion()); endif;
        if($this->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getUsuarioModificacion()); endif;
        if($this->getEliminado()) : $a_Fields['Eliminado'] = ($this->getEliminado()); endif;
        if($this->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getUsuarioEliminado()); endif;
        if($this->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getFechaEliminado()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO pla_empresa (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdEmpresa())
      {
        $a_Fields = array();

        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getDescripcion()); endif;
        if($this->getRUC()) : $a_Fields['RUC'] = ($this->getRUC()); endif;
        if($this->getRutaLogo()) : $a_Fields['RutaLogo'] = ($this->getRutaLogo()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;
        if($this->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getFechaModificacion()); endif;
        if($this->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getUsuarioModificacion()); endif;
        if($this->getEliminado()) : $a_Fields['Eliminado'] = ($this->getEliminado()); endif;
        if($this->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getUsuarioEliminado()); endif;
        if($this->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getFechaEliminado()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE pla_empresa SET ".$sStringField." WHERE 1 AND IdEmpresa='".$this->getIdEmpresa()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdEmpresa())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM pla_empresa WHERE 1 AND IdEmpresa='".$this->getIdEmpresa()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdEmpresa)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdEmpresa, Descripcion, RUC, RutaLogo, Estado, FechaCreacion, UsuarioCreacion, FechaModificacion, UsuarioModificacion, Eliminado, UsuarioEliminado, FechaEliminado FROM pla_empresa WHERE 1 AND IdEmpresa='".$vIdEmpresa."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_PlaEmpresaDP = new PlaEmpresaDP();
    $o_PlaEmpresaDP->setIdEmpresa($o_propel->IdEmpresa);
    $o_PlaEmpresaDP->setDescripcion($o_propel->Descripcion);
    $o_PlaEmpresaDP->setRUC($o_propel->RUC);
    $o_PlaEmpresaDP->setRutaLogo($o_propel->RutaLogo);
    $o_PlaEmpresaDP->setEstado($o_propel->Estado);
    $o_PlaEmpresaDP->setFechaCreacion($o_propel->FechaCreacion);
    $o_PlaEmpresaDP->setUsuarioCreacion($o_propel->UsuarioCreacion);
    $o_PlaEmpresaDP->setFechaModificacion($o_propel->FechaModificacion);
    $o_PlaEmpresaDP->setUsuarioModificacion($o_propel->UsuarioModificacion);
    $o_PlaEmpresaDP->setEliminado($o_propel->Eliminado);
    $o_PlaEmpresaDP->setUsuarioEliminado($o_propel->UsuarioEliminado);
    $o_PlaEmpresaDP->setFechaEliminado($o_propel->FechaEliminado);
    return $o_PlaEmpresaDP;
  }
}